
% CS484-W13, Asst#2, Linear Systems Demo
% Run this program and answer questions in the Assignment...

Im=double(imread('einstein.tif'));
figure;colormap gray; imagesc(Im,[0 255]); axis square;
title('Original image');

ImF=fftshift(fft2(Im));
figure;colormap gray; imagesc(log(abs(ImF))); axis square;
title('Fourier transform (log magnitude)');

xx=(1:256)-129; xx=repmat(xx,256,1);
yy=(1:256)'-129; yy=repmat(yy,1,256);
rr=sqrt(xx.^2+yy.^2); % radius, spatial frequency

% Ideal lowpass filter
Radius=20; Sigma=std(-Radius:Radius); % Std deviation of step
filtG=(rr<=Radius);
figure; colormap gray; imagesc(filtG); axis square;
title('Ideal lowpass filter (fft magnitude)');

ifiltG=real(fftshift(ifft2(fftshift(filtG))));
figure; hw=32; mesh(ifiltG(129-hw:129+hw,129-hw:129+hw));
title('ifft of Ideal lowpass filter')

ImFfiltered=ImF.*filtG;
Imfiltered=real(ifft2(fftshift(ImFfiltered)));
figure; colormap gray; imagesc(Imfiltered); axis square;
title('Ideal lowpass filtered image');

% Smoothed lowpass filter
filtG=exp(-0.5*(rr.^2)/(Sigma^2));
figure; colormap gray; imagesc(filtG); axis square;
title('Gaussian lowpass filter (fft magnitude)');

ifiltG=real(fftshift(ifft2(fftshift(filtG))));
figure; hw=32; mesh(ifiltG(129-hw:129+hw,129-hw:129+hw));
title('ifft of Gaussian lowpass filter');

ImFfiltered=ImF.*filtG;
Imfiltered=real(ifft2(fftshift(ImFfiltered)));
figure; colormap gray; imagesc(Imfiltered); axis square;
title('Gaussian lowpass filtered image');
